/*
 * Common buffer functionality for contexts and other shared memory resources.
 *
 * Copyright (C) 2020 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#pragma once

#include <fsserver/resource.h>



/* A mix-in providing support for obtaining buffers. */

class BufferSupport
{
public:
  /* Support for interface-specified operations. Specific operations will
     call this generic method. */

  virtual long buffer(l4_cap_idx_t *cap);

  /* Specialisation of the buffer object instantiation process, returning the
     appropriate resource. */

  virtual Resource *buffer_resource(void *buffer, unsigned long buffer_size) = 0;
};
